import Head from 'next/head';
import type { NextPage } from 'next';
import Image from 'next/image';
import { useState } from 'react';
import useSWR from 'swr';
import styles from '../styles/Home.module.css';

interface Item {
  label: string;
  picture: string;
}

const Home: NextPage = () => {
  const [label, setLabel] = useState<string>('');
  const [picture, setPicture] = useState<string>('');

  const fetcher = (url) => fetch(url).then((res) => res.json());

  const { data, error } = useSWR('/api/posts', fetcher, {
    refreshInterval: 1000,
  });

  // Fonction  qui permet d'écrire en DB un nouvel Item
  const submitHandler = async (e: any) => {
    e.preventDefault();
    try {
      const body = { label, picture };
      await fetch('/api/create', {
        method: 'POST',
        headers: { 'Content-Type': 'application/json' },
        body: JSON.stringify(body),
      });
    } catch (error) {
      console.error(error);
    }
  };

  // Fonction qui permet de vider les champs des inputs
  const resetInputFields = () => {
    setTimeout(() => {
      setLabel('');
      setPicture('');
    }, 3000);
  };

  return (
    <div className={styles.container}>
      <Head>
        <title>Prisma-App</title>
        <meta name='description' content='Generated by create next app' />
        <link rel='icon' href='/favicon.ico' />
      </Head>
      <main>
        <form className={styles.form} onSubmit={submitHandler}>
          <input
            className={styles.input}
            type='text'
            placeholder='Label'
            autoFocus
            onChange={(e) => setLabel(e.target.value)}
          />
          <input
            className={styles.input}
            type='text'
            placeholder='Picture'
            autoFocus
            onChange={(e) => setPicture(e.target.value)}
          />
          <input type='submit' value='Submit' onClick={resetInputFields} />
        </form>
        <div className={styles.right}>
          <h1>Items</h1>
          {(!data || data.length == 0) && 'You have no items.'}

          {data &&
            data.map(({ label, picture }: Item) => (
              <ul>
                <li>{label}</li>
                <li>
                  <img src={picture} width={100} height={100} />
                </li>
              </ul>
            ))}
        </div>
      </main>
    </div>
  );
};

export default Home;
